﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Abstractions.Mvp;

namespace Abstractions
{
    public partial class DisplayUser : System.Web.UI.Page, IDisplayUserView
    {
        private DisplayUserPresenter m_presenter;

        protected DisplayUserPresenter Presenter
        {
            get
            {
                if (this.m_presenter == null)
                {
                    this.m_presenter = new DisplayUserPresenter(this);
                }

                return this.m_presenter;
            }
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            this.Presenter.OnInit();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.Presenter.OnLoad();
        }

        public User UserToDisplay { get; set; }

        bool IView.IsPostBack { get { return this.IsPostBack; } }

        private HttpContextBase m_context;

        HttpContextBase IView.Context
        {
            get
            {
                if (this.m_context == null)
                {
                    this.m_context = new HttpContextWrapper(this.Context);
                }

                return this.m_context;
            }
        }
    }
}
