﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using AsyncAction.Async;
using System.Net;
using System.IO;
using System.Data.SqlClient;
using System.Threading;
using System.Text;

namespace AsyncAction.Controllers
{
    [HandleError]
    public class HomeController : AsyncController
    {
        public ActionResult Index()
        {
            ViewData["Title"] = "Home Page";
            ViewData["Message"] = "Welcome to ASP.NET MVC!";

            return View();
        }

        public ActionResult About()
        {
            ViewData["Title"] = "About Page";

            return View();
        }

        private HttpWebRequest m_searchRequest;

        public IAsyncResult BeginSearch(AsyncCallback cb, object extraData)
        {
            this.m_searchRequest = (HttpWebRequest)HttpWebRequest.Create("http://jeffreyzhao.cnblogs.com");
            return this.m_searchRequest.BeginGetResponse(cb, extraData);
        }

        public ActionResult EndSearch(IAsyncResult asyncResult)
        {
            using (var streamReader = new StreamReader(this.m_searchRequest.EndGetResponse(asyncResult).GetResponseStream()))
            {
                return this.Content(streamReader.ReadToEnd());  
            }
        }
    }
}
