﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Mvc;
using System.Web.Routing;

namespace ModelBinder
{
    public partial class Display : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            this.UserToDisplay = this.GetModel<User>("user", p => p != "Password");
        }

        protected User UserToDisplay { get; private set; }

        #region ModelBinderHelpers

        public T GetModel<T>(string modelName, Predicate<string> propertyFilter)
        {
            ControllerContext controllerContext = new ControllerContext(
                new HttpContextWrapper(this.Context),
                new RouteData(),
                new MockController());

            var bindingContext = new ModelBindingContext(
                controllerContext,
                new FormCollection(this.Request.Form),
                typeof(T),
                modelName,
                null,
                null,
                propertyFilter);
            
            return (T)new DefaultModelBinder().BindModel(bindingContext).Value;
        }

        private class MockController : ControllerBase
        {
            protected override void ExecuteCore()
            {
                throw new NotSupportedException();
            }
        }

        #endregion
    }
}
